import java.util.*;

/**
 * Write a description of class Compressor here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Compressor
{
    /**
     * Create a czp compressor.
     */
    public Compressor()
    {
    }

    /**
     * 
     */
    public List compress(List text)
    {
        if(text.size() == 0)
            return new ArrayList();
           
        List compressed = new ArrayList();
        Iterator it = text.iterator();
        
        // read first character of next sequence and start counting
        Character seqChar = (Character)it.next();
        int seqCount = 1;
        
        // read sequence
        while(it.hasNext()) {
            Character ch = (Character)it.next();
            if(ch.equals(seqChar)) {
                // if we have the same character as before, we ae in
                // a sequence - just count
                seqCount++;
            }
            else {
                // if the character is different, store the previous 
                // sequence and take this char as the start of a new one.
                storeCode(seqChar, seqCount, compressed);
                seqChar = ch;
                seqCount = 1;
            }
        }
        // out of characters. store the last sequence we found
        storeCode(seqChar, seqCount, compressed);
        
        return compressed;
    }
    
    /**
     * Store the code for a sequence of characters into a compressed
     * char list.
     * 
     * @param ch  The character in the sequence
     * @param count  The length of the sequence
     * @param list  The czp format character list to store into
     */
    private void storeCode(Character ch, int count, List list)
    {
        list.add(ch);
        list.add(new Character((char) count));
    }

    /**
     */
    public List uncompress(List compressed)
    {
        if(compressed.size() == 0)
            return new ArrayList();

        List text = new ArrayList();
        Iterator it = compressed.iterator();
        
        while(it.hasNext()) {
            // read the next char/count pair
            Character ch = (Character)it.next();
            Character countCh = (Character)it.next();
            int count = countCh.charValue();

            // write character sequence to text            
            for(int i=0; i<count; i++) {
                text.add(ch);
            }
        }
        return text;
                   
    }

}
